/*  Microsoft C and Turbo C Binary Position Read Sample Program
    Program name: BINREAD.C

    To create an executable program, BINREAD.EXE, (medium memory model),
    with the command line compiler and linker, use the following command:

    Microsoft C:    cl /AM binread.c mcm_mm.obj
    Borland C:      tcc -mm binread.c tcc_mm.obj

    .  mcm_mm.obj is on your MotionMaster 2000 diskette in directory /MC51
    .  tcm_mm.obj is on your MotionMaster 2000 diskette in directory /TC20
*/
#include <string.h>

char  tp[] = "TP";
char  ts[] = "TS";
char  cp[] = "CP";
char  da[] = "DA";
char  dv[] = "DV";
char  dp[] = "DP";
char  tf[] = "TF";
int   mm_add;
char  cmd_copy1[80];
char  cmd_copy2[80];
char  response[80];
char  *cmd;
char  cr[]={'\r'};
char  *cmd_parse;
int  cmd_num;
long int binpos;

char  *cmd_array[15]=
{
"1fo00",             /* set mode=ASCII*/
"va10000",
"ac75000",
"dh;pr+1000;ws",     /*initiate move and wait for stop*/
"fo04",              /* set mode=binary */
"TP",
"fo00",              /* set mode=ASCII */
"DV",
"DA",
"end"
};

main()
{
     mm_add=0x340;
     cmd_num = 0;
     while (strcmp(cmd_array[cmd_num],"end") != 0)
     {
        strcpy(cmd_copy1,cmd_array[cmd_num]);  /* make 2 copies of command*/
        strcpy(cmd_copy2,cmd_array[cmd_num]);
        cmd = strcat(cmd_copy1, cr);
        mmsend(cmd,mm_add);            /* pass command pointer & board addr.*/
        test_response();
        ++cmd_num;
     }
}

test_response()
{
     cmd_parse=strstr(cmd_copy2,tp);    /* test if "tp" is last in command*/
     if (strcmp(cmd_parse,tp) == 0)
     {
        binread(&binpos,mm_add);
        printf("\nCurrent Binary Position: %li",binpos);
     }

     cmd_parse=strstr(cmd_copy2,ts);
     if (strcmp(cmd_parse,ts) == 0)
     {
        mmread(response,mm_add);
        printf("\nCurrent Status: (See User's Manual for Interpretation) %s",response);
     }

     cmd_parse=strstr(cmd_copy2,cp);
     if (strcmp(cmd_parse,cp) == 0)
     {
        mmread(response,mm_add);
        printf("\nCompile Message: %s",response);
        mmread(response,mm_add);
        printf("\nCompile Message: %s",response);
     }

     cmd_parse=strstr(cmd_copy2,dv);
     if (strcmp(cmd_parse,dv) == 0)
     {
        mmread(response,mm_add);
        printf("\nCurrent Set Velocity: %s",response);
     }

     cmd_parse=strstr(cmd_copy2,da);
     if (strcmp(cmd_parse,da) == 0)
     {
        mmread(response,mm_add);
        printf("\nCurrent Set Acceleration: %s",response);
     }

     cmd_parse=strstr(cmd_copy2,dp);
     if (strcmp(cmd_parse,dp) == 0)
     {
        mmread(response,mm_add);
        printf("\nCurrent Desired Position: %s",response);
     }

     cmd_parse=strstr(cmd_copy2,tf);
     if (strcmp(cmd_parse,tf) == 0)
     {
        mmread(response,mm_add);
        printf("\nCurrent DC Motor Filters: %s",response);
     }
}
