/*  Microsoft C Sample Program Using High Level Handshaking

    This program shows the equivalent C code for the assembly
    written MotionMaster 2000 data transfer software modules.

    The function mm_csend() in this program is the C code equivalent
    of the normal MotionMaster 2000 mmsend() function.

    The function mm_cread() in this program is the C code equivalent
    of the normal MotionMaster 2000 mmread() function.

    See the normal MotionMaster 2000 data transfer routines written in
    assembly stored under file names:  *.ASM provided to you on the
    MotionMaster 2000 diskette.

    To create .EXE file, type:    cl /AM hi_mc51.c

*/
#include <string.h>
#include <dos.h>

char  tp[] = "TP";
char  ts[] = "TS";
char  cp[] = "CP";
char  da[] = "DA";
char  dv[] = "DV";
char  dp[] = "DP";
char  tf[] = "TF";
int   mm_add;
char  cmd_copy1[80];
char  cmd_copy2[80];
char  response[80];
char  cmd[80];
char  cr[]={'\r'};
char  *cmd_parse;
int  cmd_num;

char  *cmd_array[4] =
{
"1FM01",
"1PR100;WS",
"TP",
"end"
};

main()
{
     mm_add=0x340;
     cmd_num = 0;
     while (strcmp(cmd_array[cmd_num],"end") != 0)
     {
        strcpy(cmd,cmd_array[cmd_num]);  /* make 2 copies of command*/
        strcpy(cmd_copy2,cmd_array[cmd_num]);
        mm_csend(cmd);            /* pass command pointer & board addr.*/
        test_response();
        ++cmd_num;
     }
}

test_response()
{
     cmd_parse=strstr(cmd_copy2,tp);    /* test if "tp" is last in command*/
     if (strcmp(cmd_parse,tp) == 0)
     {
        mm_cread(response);
        printf("\nCurrent Position: %s",response);
     }

     cmd_parse=strstr(cmd_copy2,ts);
     if (strcmp(cmd_parse,ts) == 0)
     {
        mm_cread(response,mm_add);
        printf("\nCurrent Status: (See User's Manual for Interpretation) %s",response);
     }

     cmd_parse=strstr(cmd_copy2,cp);
     if (strcmp(cmd_parse,cp) == 0)
     {
        mm_cread(response,mm_add);
        printf("\nCompile Message: %s",response);
        mm_cread(response,mm_add);
        printf("\nCompile Message: %s",response);
     }

     cmd_parse=strstr(cmd_copy2,dv);
     if (strcmp(cmd_parse,dv) == 0)
     {
        mm_cread(response,mm_add);
        printf("\nCurrent Set Velocity: %s",response);
     }

     cmd_parse=strstr(cmd_copy2,da);
     if (strcmp(cmd_parse,da) == 0)
     {
        mm_cread(response,mm_add);
        printf("\nCurrent Set Acceleration: %s",response);
     }

     cmd_parse=strstr(cmd_copy2,dp);
     if (strcmp(cmd_parse,dp) == 0)
     {
        mm_cread(response,mm_add);
        printf("\nCurrent Desired Position: %s",response);
     }

     cmd_parse=strstr(cmd_copy2,tf);
     if (strcmp(cmd_parse,tf) == 0)
     {
        mm_cread(response,mm_add);
        printf("\nCurrent DC Motor Filters: %s",response);
     }
}

mm_csend(char *cmd)
{
     int mm_add=0x340;
     char *i, cmd2[80];

     strcat(strcpy(cmd2,cmd),"\r");
     i = cmd2;
     while(*i != 0)
     {
        _enable();                   /* enable interrupt */
        while(inp(mm_add+1) != 128);
        outp(mm_add,*i);
        outp(mm_add+1,128);
        while(inp(mm_add+1) != 0);
        _disable();                  /* disable interrupt */
        outp(mm_add+1,0);
        i += 1;
     }
     while(inp(mm_add+1) != 128);
     _enable();                      /* enable interrupt */
}

mm_cread(char *resp)
{
     int mm_add=0x340;
     char *i;

     i = resp;
     do
     {
        while(inp(mm_add+1) != 0);
        outp(mm_add+1,128);
        while(inp(mm_add+1) < 128);
        *i = inp(mm_add);
        i += 1;
        outp(mm_add+1,0);
     }
     while(*(i-1) != 10);
     while(inp(mm_add+1) != 128);
}
