
; Use this interface module if you compile with LARGE memory model

           .model medium
           .code
           public _mmsend
           public _mmread
           public _binread

;************************************************

_mmsend     proc

off_cmd_add    equ  <6[bp]>       ;C pushes parms. in reverse order
seg_cmd_add    equ  <8[bp]>
mm_add         equ  <10[bp]>      ;last specified in call -> first onto stack

           push bp
           mov bp,sp

           push  ax
           push  bx
           push  dx
           push  ds
           push  si

           mov ds,seg_cmd_add
           mov si,off_cmd_add     ;string address (offset) into SI

           mov dx,mm_add          ;port address into DX
           inc dx

wait_mm_rdy:
           in  al,dx              ;wait for MM2000 to be ready
           cmp al,80h             ;bit 7=1
           jne wait_mm_rdy

           mov al,byte ptr[si]    ;get data
           mov bl,al              ;save data

           dec dx
           out dx,al              ;output data
           inc dx

           or  al,80h             ;send DAV signal
           out dx,al              ;output data and DAV signal

wait_mm_dac:
           in  al,dx              ;wait for MM2000 to accept data
           cmp al,0               ;i.e. not ready -- bit 7=0
           jne wait_mm_dac

           cli                    ;disable interrupts

           mov al,0               ;set DAV not data valid and
           out dx,al              ;remove data

           inc si
           cmp bl,0dh             ;test if last char. sent
           je wait_mm_rdy_exit

           sti                    ;enable interrupt
           jmp wait_mm_rdy

wait_mm_rdy_exit:
           in  al,dx              ;wait for MM2000 to be ready for exit
           cmp al,80h             ;bit 7=1
           jne wait_mm_rdy_exit

           sti                    ;enable interrupt
           pop si
           pop ds
           pop dx
           pop bx
           pop ax
           pop bp
           ret                    ;C cleans stack; no parm on ret statement

_mmsend     endp

;************************************************

_mmread     proc

off_resp_add   equ  <6[bp]>
seg_resp_add   equ  <8[bp]>
mm_addr        equ  <10[bp]>

           push bp
           mov bp,sp

           push  ax
           push  bx
           push  dx
           push  ds
           push  di

           mov ds,seg_resp_add
           mov di,off_resp_add          ;string address (offset) into DI

           mov dx,mm_addr           ;port address into DX
           inc dx

wait_mm_ready:
           in  al,dx                ;wait for MM2000 not ready to receive
           cmp al,0                 ;i.e. ready to send
           jne wait_mm_ready

pc_ready_for_data:
           mov   al,80h
           out   dx,al              ;send PC ready to interface

wait_mm_dav:
           in    al,dx              ;wait for MM2000 to indicate DAV
           cmp   al,80h             ;bit 7=1
           jb    wait_mm_dav        ;jump if below

           dec   dx
           in    al,dx
           inc   dx

           mov   [di],al            ;store data at string address
           mov   bl,al              ;save received character
           inc   di

           mov   al,0               ;indicate to MM2000 data accepted
           out   dx,al              ;set bit 7=0
           cmp   bl,0ah
           je    exit

wait_mm_ndav:
           in    al,dx              ;wait for MM2000 to indicate not DAV
           cmp   al,0               ;bit 7=0
           jne   wait_mm_ndav

           jmp   pc_ready_for_data

;   Exit if character received is line feed

exit:
           in   al,dx
           cmp  al,80h
           jne  exit

           xor  al,al             ;terminate string with NULL char
           mov  [di-2],al         ;resp$=string$ + NULL

           pop  di
           pop  ds
           pop  dx
           pop  bx
           pop  ax
           pop  bp
           ret

_mmread     endp

;---------------------------------------

_binread   proc

off_bin_pos    equ  <6[bp]>
seg_bin_pos    equ  <8[bp]>
mm_addr        equ  <10[bp]>

           push bp
           mov bp,sp

           push  ax
           push  bx
           push  dx
           push  di
           push  ds

           mov dx,mm_addr           ;port address into DX
           inc dx                   ;dx points to base+1

           mov ds,seg_bin_pos
           mov bx,off_bin_pos
           mov cx,bx
           add cx,3
           dec bx

bwait_mm_ready:
           in  al,dx                ;wait for MM2000 not ready to receive
           cmp al,0                 ;i.e. ready to send
           jne bwait_mm_ready

bpc_ready_for_data:
           mov   al,80h
           out   dx,al              ;send PC ready to interface

bwait_mm_dav:
           in    al,dx              ;wait for MM2000 to indicate DAV
           cmp   al,80h             ;bit 7=1
           jb    bwait_mm_dav       ;jump if below

;   [al] = handshake bit + data

           dec   dx                 ;dx points to base
           in    al,dx
           inc   bx
           mov   [bx],al
           inc   dx                 ;dx points to base+1

           mov   al,0               ;indicate to MM2000 data accepted
           out   dx,al              ;set bit 7=0

           cmp   bx,cx
           je    bexit

bwait_mm_ndav:
           in    al,dx              ;wait for MM2000 to indicate not DAV
           cmp   al,0               ;bit 7=0
           jne   bwait_mm_ndav

           jmp   bpc_ready_for_data

;   Exit if character received is line feed

bexit:
           in   al,dx
           cmp  al,80h
           jne  bexit

;           xor  al,al             ;terminate string with NULL char
;           mov  [bx+4],al         ;pos%=pos% + NULL

           pop  ds
           pop  di
           pop  dx
           pop  bx
           pop  ax
           pop  bp
           ret

_binread   endp

           end

